/* comparator.h--comparator interface
 * Rob Earhart
 */
/***********************************************************
        Copyright 1998 by Carnegie Mellon University

                      All Rights Reserved

Permission to use, copy, modify, and distribute this software and its
documentation for any purpose and without fee is hereby granted,
provided that the above copyright notice appear in all copies and that
both that copyright notice and this permission notice appear in
supporting documentation, and that the name of Carnegie Mellon
University not be used in advertising or publicity pertaining to
distribution of the software without specific, written prior
permission.

CARNEGIE MELLON UNIVERSITY DISCLAIMS ALL WARRANTIES WITH REGARD TO
THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND
FITNESS, IN NO EVENT SHALL CARNEGIE MELLON UNIVERSITY BE LIABLE FOR
ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT
OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
******************************************************************/

#ifndef COMPARATOR_H
#define COMPARATOR_H

typedef         result_t
compare_equality_proc_t(const str_t * first,
			const str_t * second,
			eq_result_t * dest);

typedef result_t
compare_ordering_proc_t(const str_t * first,
			const str_t * second,
			compare_result_t * dest);

typedef result_t
compare_prefix_proc_t(const str_t * match,
		      const str_t * data,
		      eq_result_t * dest);

typedef result_t
compare_substring_proc_t(const str_t * match,
			 const str_t * data,
			 void **cache,
			 eq_result_t * dest);

extern result_t
comparator_lookup_equality(str_t * name,
			   compare_equality_proc_t ** dest);

extern result_t
comparator_lookup_ordering(str_t * name,
			   compare_ordering_proc_t ** dest);

extern result_t
comparator_lookup_prefix(str_t * name,
			 compare_prefix_proc_t ** dest);

extern result_t
comparator_lookup_substring(str_t * name,
			    compare_substring_proc_t ** dest);

#endif				/* COMPARATOR_H */
