/* dataset_db_fac.h--dataset db factory interface
 * Rob Earhart
 */
/***********************************************************
        Copyright 1998 by Carnegie Mellon University

                      All Rights Reserved

Permission to use, copy, modify, and distribute this software and its
documentation for any purpose and without fee is hereby granted,
provided that the above copyright notice appear in all copies and that
both that copyright notice and this permission notice appear in
supporting documentation, and that the name of Carnegie Mellon
University not be used in advertising or publicity pertaining to
distribution of the software without specific, written prior
permission.

CARNEGIE MELLON UNIVERSITY DISCLAIMS ALL WARRANTIES WITH REGARD TO
THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND
FITNESS, IN NO EVENT SHALL CARNEGIE MELLON UNIVERSITY BE LIABLE FOR
ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT
OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
******************************************************************/

#ifndef DATASET_DB_FAC_H
#define DATASET_DB_FAC_H

#include "../util/str.h"
#include "dataset_db.h"

/* dataset_db_fac is a singleton object which, given a dataset_db
 * path, returns the associated dataset_db (with an incremented
 * refcount).  It's implemented seperately (instead of just being
 * dataset_db_alloc() in order to guarantee that the same name maps to
 * the same object every time; this is important for locking. */

extern          result_t
dataset_db_fac_lookup(const str_t * name,
		      dataset_db_t ** dest);

/* Used by dataset_dbs which think they're out of references... */
extern result_t dataset_db_fac_check_norefs(dataset_db_t * db);

#endif				/* DATASET_DB_FAC_H */
