PC	[^\"]
AN	[A-Z_a-z0-9]

%{
#include "error_parse.h"
#undef yywrap

#ifdef __STDC__
extern char *ds(const char *string);
#else
extern char *ds();
#endif

#ifdef STDC_HEADERS
#include <string.h>
#else
/* If they don't have stdc headers, they usually have rindex */
#define strchr(s,c) rindex(s,c)
#endif

int lineno = 1;
%}

%%

error_table	return ERROR_TABLE;
et		return ERROR_TABLE;
error_code	return ERROR_CODE_ENTRY;
ec		return ERROR_CODE_ENTRY;
end		return END;

[\t ]		;
[\n]		{ lineno++; }

\"{PC}*\"	{ register char *p; yylval.dynstr = ds(yytext+1);
		  if (p=strchr(yylval.dynstr, '"')) *p='\0';
		  return QUOTED_STRING;
		}

{AN}*	{ yylval.dynstr = ds(yytext); return STRING; }

#.*\n		{ lineno++; }

.		{ return (*yytext); }
%%
#ifndef lint
static char rcsid_et_lex_lex_l[] = "$Header: /cvs/src/com_err/et_lex.l,v 1.1.1.1 1998/10/01 20:43:04 rob Exp $";
#endif

int yywrap() {
  return 1;
}
