/* dispatch.h - dispatch queue interface
 * Rob Earhart
 */
/***********************************************************
        Copyright 1998 by Carnegie Mellon University

                      All Rights Reserved

Permission to use, copy, modify, and distribute this software and its
documentation for any purpose and without fee is hereby granted,
provided that the above copyright notice appear in all copies and that
both that copyright notice and this permission notice appear in
supporting documentation, and that the name of Carnegie Mellon
University not be used in advertising or publicity pertaining to
distribution of the software without specific, written prior
permission.

CARNEGIE MELLON UNIVERSITY DISCLAIMS ALL WARRANTIES WITH REGARD TO
THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND
FITNESS, IN NO EVENT SHALL CARNEGIE MELLON UNIVERSITY BE LIABLE FOR
ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT
OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
******************************************************************/

#ifndef DISPATCH_H
#define DISPATCH_H

typedef struct dispatch_queue_s dispatch_queue_t;

typedef void    dispatch_task_t(void *rock);

extern          result_t
dispatch_queue_alloc(dispatch_queue_t ** queue,
		     unsigned concurrency);

/* queues a task to be run at some point */
extern result_t
dispatch_enqueue(dispatch_queue_t * queue,
		 dispatch_task_t * task,
		 void *rock);

/* causes no more tasks to be run
 * returns when all currently dispatched tasks are complete. */
extern result_t dispatch_queue_shutdown(dispatch_queue_t * queue);

/* frees a queue */
extern result_t dispatch_queue_free(dispatch_queue_t ** queue);

#endif				/* DISPATCH_H */
